## kapow 1.6.2

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021-2023 Graeme Gott <graeme@gottcode.org>
#
# SPDX-License-Identifier: GPL-3.0-or-later

cmake_minimum_required(VERSION 3.16)

# Configure project
project(kapow VERSION 1.6.2 LANGUAGES CXX)

set(project_copyright "2008-2024 Graeme Gott")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

find_package(Qt6 REQUIRED COMPONENTS Core Gui LinguistTools Network PrintSupport Widgets)
include(GNUInstallDirs)

add_compile_definitions(
	QT_NO_KEYWORDS
	$<$<CONFIG:DEBUG>:QT_STRICT_ITERATORS>
	$<$<CONFIG:DEBUG>:QT_NO_NARROWING_CONVERSIONS_IN_CONNECT>
	$<$<CONFIG:DEBUG>:QT_DISABLE_DEPRECATED_BEFORE=0x060600>
)

# Version number
include(cmake/AddVersionCompileDefinition.cmake)
add_version_compile_definition(src/main.cpp VERSIONSTR)

# Create tests
option(ENABLE_TESTS "Enable unit tests" OFF)
if (ENABLE_TESTS)
	find_package(Qt6 REQUIRED COMPONENTS Test)
	enable_testing()
	add_subdirectory(tests)
endif()

# Create translations
file(GLOB translations_SRCS translations/*.ts)
qt6_add_translation(translations_QM ${translations_SRCS})

add_custom_target(update_translations
	COMMAND Qt6::lupdate -no-obsolete -locations none src -ts ${translations_SRCS}
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
	VERBATIM
)

# Create program
qt6_add_executable(kapow
	src/contact.cpp
	src/date_editor.cpp
	src/filter_model.cpp
	src/locale_dialog.cpp
	src/main.cpp
	src/paths.cpp
	src/project.cpp
	src/project_delegate.cpp
	src/rates.cpp
	src/report.cpp
	src/session.cpp
	src/session_delegate.cpp
	src/session_dialog.cpp
	src/session_model.cpp
	src/settings.cpp
	src/time_editor.cpp
	src/window.cpp
	src/3rdparty/qtsingleapplication/qtsingleapplication.cpp
	src/3rdparty/qtsingleapplication/qtlocalpeer.cpp
	${translations_QM}
)

target_include_directories(kapow PRIVATE
	src/3rdparty/qtsingleapplication
)

target_link_libraries(kapow PRIVATE
	Qt6::Core
	Qt6::Gui
	Qt6::Network
	Qt6::PrintSupport
	Qt6::Widgets
)

# Optimize build
option(ENABLE_LINK_TIME_OPTIMIZATION "Enable link time optimization" OFF)
if(ENABLE_LINK_TIME_OPTIMIZATION)
	include(CheckIPOSupported)
	check_ipo_supported(RESULT result)
	if(result)
		set_target_properties(kapow PROPERTIES INTERPROCEDURAL_OPTIMIZATION TRUE)
	endif()
endif()

option(ENABLE_STRIP "Enable automatic stripping of builds" OFF)
if(ENABLE_STRIP)
	add_custom_command(TARGET kapow
		POST_BUILD
		COMMAND ${CMAKE_STRIP} $<TARGET_FILE:kapow>
	)
endif()

# Install
target_sources(kapow PRIVATE icons/icons.qrc)

if(APPLE)
	set(datadir "../Resources")

	set_target_properties(kapow PROPERTIES
		OUTPUT_NAME Kapow
		MACOSX_BUNDLE TRUE
		MACOSX_BUNDLE_INFO_PLIST ${CMAKE_SOURCE_DIR}/mac/Info.plist.in
	)

	include(cmake/BundleResources.cmake)
	bundle_data(kapow ${CMAKE_SOURCE_DIR}/icons/kapow.icns Resources)
	bundle_translations(kapow "${translations_QM}")
elseif(WIN32)
	set(datadir ".")

	# Use Qt6 macro until CMake provides something
	# https://bugreports.qt.io/browse/QTBUG-87618
	set_target_properties(kapow PROPERTIES
		OUTPUT_NAME Kapow
		WIN32_EXECUTABLE TRUE
		QT_TARGET_VERSION "${PROJECT_VERSION}"
		QT_TARGET_COMPANY_NAME "Graeme Gott"
		QT_TARGET_DESCRIPTION "Punch clock"
		QT_TARGET_COPYRIGHT "\\xA9 ${project_copyright}"
		QT_TARGET_PRODUCT_NAME "Kapow"
		QT_TARGET_RC_ICONS ${CMAKE_SOURCE_DIR}/icons/kapow.ico
	)
	_qt_internal_generate_win32_rc_file(kapow)
else()
	file(RELATIVE_PATH datadir ${CMAKE_INSTALL_FULL_BINDIR} ${CMAKE_INSTALL_FULL_DATADIR}/kapow)

	install(TARGETS kapow RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
	install(FILES ${translations_QM} DESTINATION ${CMAKE_INSTALL_DATADIR}/kapow/translations)
	install(FILES doc/kapow.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT doc)
	install(DIRECTORY icons/hicolor DESTINATION ${CMAKE_INSTALL_DATADIR}/icons)
	install(FILES icons/kapow.appdata.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)
	install(FILES icons/kapow.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
endif()

set_property(SOURCE src/main.cpp APPEND PROPERTY COMPILE_DEFINITIONS KAPOW_DATADIR="${datadir}")

## kapow 1.5.8

=== debian/changelog ===
kapow (1.5.8-0.1~mx17+1) mx; urgency=medium

  * Import 1.5.8 release.
  * Update debian/copyright dates.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 04 Aug 2018 13:30:57 -0700

kapow (1.5.6-0.1~mx17+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 29 May 2018 10:50:02 -0700

kapow (1.5.6-0ppa1~trusty1) trusty; urgency=low

  * Update to 1.5.6

 -- Graeme Gott <graeme@gottcode.org>  Tue, 29 May 2018 10:51:49 +0000

kapow (1.5.5-0ppa1~trusty1) trusty; urgency=low

  * Update to 1.5.5

 -- Graeme Gott <graeme@gottcode.org>  Wed, 27 Dec 2017 17:23:03 +0000

kapow (1.5.4-0ppa1~trusty1) trusty; urgency=low

  * Update to 1.5.4

 -- Graeme Gott <graeme@gottcode.org>  Fri, 27 Oct 2017 19:19:57 +0000

kapow (1.5.3-0ppa1~trusty1) trusty; urgency=low

  * Update to 1.5.3

 -- Graeme Gott <graeme@gottcode.org>  Sat, 05 Aug 2017 13:12:58 +0000

kapow (1.5.2-0ppa1~trusty1) trusty; urgency=low

  * Update to 1.5.2

 -- Graeme Gott <graeme@gottcode.org>  Thu, 03 Nov 2016 15:37:54 +0000

kapow (1.5.1-0ppa1~trusty1) trusty; urgency=low

  * Update to 1.5.1

 -- Graeme Gott <graeme@gottcode.org>  Mon, 10 Oct 2016 10:33:26 +0000

kapow (1.5.0-0ppa1~trusty1) trusty; urgency=low

  * Update to 1.5.0
    - Disabled removing projects with running timers in subprojects.
    - Properly stop all timers when program exits.
    - Added starting, stopping, or canceling sessions from sidebar.
    - Added support for high DPI displays.
    - Added AppData file.
    - Added manpage.
    - Added unit tests.
    - Refactored code.
    - Simplified build system.
    - Switched to Qt 5.
    - Switched to C++11.
    - FIXED: Could not add session longer than one day.
    - FIXED: Broken system tray icon support in Windows.
    - FIXED: Setting locale did not change layout direction.
    - FIXED: SessionModel ids were treated as signed ints.
    - Translation updates: Arabic, Bulgarian, Czech, Danish, Dutch, French,
      German, Greek, Lithuanian, Norwegian, Polish, Portuguese (Brazil),
      Romanian, Russian, Spanish, Turkish, Ukrainian.

 -- Graeme Gott <graeme@gottcode.org>  Sat, 17 Sep 2016 22:47:58 +0000

kapow (1.4.4.2-0ppa1~trusty1) trusty; urgency=low

  * Update to 1.4.4.2
    - Fix migrating time data

 -- Graeme Gott <graeme@gottcode.org>  Mon, 12 May 2014 22:21:20 +0000

kapow (1.4.4.1-0ppa3~trusty1) trusty; urgency=low

  * Fix compiler warnings

 -- Graeme Gott <graeme@gottcode.org>  Mon, 12 May 2014 13:15:35 +0000

kapow (1.4.4.1-0ppa2~trusty1) trusty; urgency=low

  * Switch to Qt 5
  * Update copyright file

 -- Graeme Gott <graeme@gottcode.org>  Sun, 11 May 2014 16:43:09 +0000

kapow (1.4.4.1-0ppa1~trusty1) trusty; urgency=low

  * Initial release

 -- Graeme Gott <graeme@gottcode.org>  Tue, 25 Jun 2013 18:02:01 +0000

=== debian/control ===
Source: kapow
Section: x11
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Graeme Gott <graeme@gottcode.org>
Build-Depends: debhelper (>= 9), qtbase5-dev, qttools5-dev-tools
Standards-Version: 3.9.8
Homepage: https://gottcode.org/kapow/

Package: kapow
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: A punch clock program
 A punch clock program designed to easily keep track of your hours,
 whether you're working on one project or many. Simply clock in
 and out with the Start/Stop button. If you make a mistake in your
 hours, you can go back and edit any of the entries by double-clicking
 on the session in question. Kapow also allows you to easily keep
 track of the hours since you last billed a client, by providing a
 helpful "Billed" checkbox--the totals will reflect your work
 after the last billed session.

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT = 5

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --parallel

#override_dh_installchangelogs:
#	dh_installchangelogs NEWS

=== debian/watch ===
version=3
https://github.com/gottcode/kapow/releases /gottcode/kapow/archive/v(.+)\.tar\.gz

## kapow 1.5.10

=== debian/changelog ===
kapow (1.5.10-0.1~mx19+1) mx; urgency=medium

  * Import 1.5.10 release:
    - FIXED: Did not load locales with underscores.
    - Translation updates: Italian.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 10 Jun 2020 11:44:42 -0700

kapow (1.5.9-0.1~mx19+1) mx; urgency=medium

  * Import 1.5.9 release:
    - FIXED: Window icon didn't work in Wayland.
    - Improved loading locales.
    - Improved Windows deployment.
    - Replaced deprecated code.
    - Translation updates: Czech, French.
  * Update debian/copyright dates.
  * debian/control: Now requires Qt >= 5.9, and bump to debhelper compat 10.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 23 Aug 2019 09:40:22 -0700

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,9 @@
 Priority: optional
 Maintainer: Steven Pusser <stevep@mxlinux.org>
 XSBC-Original-Maintainer: Graeme Gott <graeme@gottcode.org>
-Build-Depends: debhelper (>= 9), qtbase5-dev, qttools5-dev-tools
+Build-Depends: debhelper (>= 10),
+               qtbase5-dev (>= 5.9.0),
+               qttools5-dev-tools (>= 5.9.0)
 Standards-Version: 3.9.8
 Homepage: https://gottcode.org/kapow/

=== debian/rules ===
--- 
+++ 
@@ -9,5 +9,5 @@
 %:
 	dh $@ --parallel
 
-#override_dh_installchangelogs:
-#	dh_installchangelogs NEWS
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym

## kapow 1.6.2

=== debian/changelog ===
kapow (1.6.2-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 29 Aug 2024 23:32:22 -0700

kapow (1.6.2-0ppa1~jammy) jammy; urgency=low

  * Update to 1.6.2

 -- Graeme Gott <graeme@gottcode.org>  Tue, 16 Jan 2024 15:19:18 +0000

kapow (1.6.1-0ppa1~jammy) jammy; urgency=low

  * Update to 1.6.1

 -- Graeme Gott <graeme@gottcode.org>  Tue, 10 Jan 2023 19:14:55 +0000

kapow (1.6.0-0ppa2~jammy) jammy; urgency=low

  * Add missing dependency

 -- Graeme Gott <graeme@gottcode.org>  Fri, 27 May 2022 22:29:36 +0000

kapow (1.6.0-0ppa1~jammy) jammy; urgency=low

  * Update to 1.6.0

 -- Graeme Gott <graeme@gottcode.org>  Fri, 20 May 2022 16:33:16 +0000

kapow (1.5.10-0ppa1~jammy) jammy; urgency=low

  * Update to 1.5.10

 -- Graeme Gott <graeme@gottcode.org>  Tue, 21 Apr 2020 12:41:51 +0000

kapow (1.5.9-0ppa1~jammy) jammy; urgency=low

  * Update to 1.5.9

 -- Graeme Gott <graeme@gottcode.org>  Wed, 07 Aug 2019 13:47:37 +0000

kapow (1.5.8-0ppa1~jammy) jammy; urgency=low

  * Update to 1.5.8

 -- Graeme Gott <graeme@gottcode.org>  Fri, 20 Jul 2018 16:19:39 +0000

kapow (1.5.7-0ppa1~jammy) jammy; urgency=low

  * Update to 1.5.7

 -- Graeme Gott <graeme@gottcode.org>  Sun, 24 Jun 2018 11:57:13 +0000

kapow (1.5.6-0ppa1~jammy) jammy; urgency=low

  * Update to 1.5.6

 -- Graeme Gott <graeme@gottcode.org>  Tue, 29 May 2018 10:51:49 +0000

kapow (1.5.5-0ppa1~jammy) jammy; urgency=low

  * Update to 1.5.5

 -- Graeme Gott <graeme@gottcode.org>  Wed, 27 Dec 2017 17:23:03 +0000

kapow (1.5.4-0ppa1~jammy) jammy; urgency=low

  * Update to 1.5.4

 -- Graeme Gott <graeme@gottcode.org>  Fri, 27 Oct 2017 19:19:57 +0000

kapow (1.5.3-0ppa1~jammy) jammy; urgency=low

  * Update to 1.5.3

 -- Graeme Gott <graeme@gottcode.org>  Sat, 05 Aug 2017 13:12:58 +0000

kapow (1.5.2-0ppa1~jammy) jammy; urgency=low

  * Update to 1.5.2

 -- Graeme Gott <graeme@gottcode.org>  Thu, 03 Nov 2016 15:37:54 +0000

kapow (1.5.1-0ppa1~jammy) jammy; urgency=low

  * Update to 1.5.1

 -- Graeme Gott <graeme@gottcode.org>  Mon, 10 Oct 2016 10:33:26 +0000

kapow (1.5.0-0ppa1~jammy) jammy; urgency=low

  * Update to 1.5.0
    - Disabled removing projects with running timers in subprojects.
    - Properly stop all timers when program exits.
    - Added starting, stopping, or canceling sessions from sidebar.
    - Added support for high DPI displays.
    - Added AppData file.
    - Added manpage.
    - Added unit tests.
    - Refactored code.
    - Simplified build system.
    - Switched to Qt 5.
    - Switched to C++11.
    - FIXED: Could not add session longer than one day.
    - FIXED: Broken system tray icon support in Windows.
    - FIXED: Setting locale did not change layout direction.
    - FIXED: SessionModel ids were treated as signed ints.
    - Translation updates: Arabic, Bulgarian, Czech, Danish, Dutch, French,
      German, Greek, Lithuanian, Norwegian, Polish, Portuguese (Brazil),
      Romanian, Russian, Spanish, Turkish, Ukrainian.

 -- Graeme Gott <graeme@gottcode.org>  Sat, 17 Sep 2016 22:47:58 +0000

kapow (1.4.4.2-0ppa1~jammy) jammy; urgency=low

  * Update to 1.4.4.2
    - Fix migrating time data

 -- Graeme Gott <graeme@gottcode.org>  Mon, 12 May 2014 22:21:20 +0000

kapow (1.4.4.1-0ppa3~jammy) jammy; urgency=low

  * Fix compiler warnings

 -- Graeme Gott <graeme@gottcode.org>  Mon, 12 May 2014 13:15:35 +0000

kapow (1.4.4.1-0ppa2~jammy) jammy; urgency=low

  * Switch to Qt 5
  * Update copyright file

 -- Graeme Gott <graeme@gottcode.org>  Sun, 11 May 2014 16:43:09 +0000

kapow (1.4.4.1-0ppa1~jammy) jammy; urgency=low

  * Initial release

 -- Graeme Gott <graeme@gottcode.org>  Tue, 25 Jun 2013 18:02:01 +0000

## kapow 1.6.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,13 @@
-# SPDX-FileCopyrightText: 2021-2023 Graeme Gott <graeme@gottcode.org>
+# SPDX-FileCopyrightText: 2021-2025 Graeme Gott <graeme@gottcode.org>
 #
 # SPDX-License-Identifier: GPL-3.0-or-later
 
 cmake_minimum_required(VERSION 3.16)
 
 # Configure project
-project(kapow VERSION 1.6.2 LANGUAGES CXX)
+project(kapow VERSION 1.6.4 LANGUAGES CXX)
 
-set(project_copyright "2008-2024 Graeme Gott")
+set(project_copyright "2008-2025 Graeme Gott")
 
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
@@ -22,7 +22,7 @@
 	QT_NO_KEYWORDS
 	$<$<CONFIG:DEBUG>:QT_STRICT_ITERATORS>
 	$<$<CONFIG:DEBUG>:QT_NO_NARROWING_CONVERSIONS_IN_CONNECT>
-	$<$<CONFIG:DEBUG>:QT_DISABLE_DEPRECATED_BEFORE=0x060600>
+	$<$<CONFIG:DEBUG>:QT_DISABLE_DEPRECATED_BEFORE=0x060800>
 )
 
 # Version number
@@ -37,18 +37,28 @@
 	add_subdirectory(tests)
 endif()
 
-# Create translations
-file(GLOB translations_SRCS translations/*.ts)
-qt6_add_translation(translations_QM ${translations_SRCS})
-
-add_custom_target(update_translations
-	COMMAND Qt6::lupdate -no-obsolete -locations none src -ts ${translations_SRCS}
-	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
-	VERBATIM
-)
-
 # Create program
-qt6_add_executable(kapow
+qt_add_executable(kapow
+	# Headers
+	src/contact.h
+	src/date_editor.h
+	src/filter_model.h
+	src/locale_dialog.h
+	src/paths.h
+	src/project.h
+	src/project_delegate.h
+	src/rates.h
+	src/report.h
+	src/session.h
+	src/session_delegate.h
+	src/session_dialog.h
+	src/session_model.h
+	src/settings.h
+	src/time_editor.h
+	src/window.h
+	src/3rdparty/qtsingleapplication/qtsingleapplication.h
+	src/3rdparty/qtsingleapplication/qtlocalpeer.h
+	# Sources
 	src/contact.cpp
 	src/date_editor.cpp
 	src/filter_model.cpp
@@ -68,6 +78,7 @@
 	src/window.cpp
 	src/3rdparty/qtsingleapplication/qtsingleapplication.cpp
 	src/3rdparty/qtsingleapplication/qtlocalpeer.cpp
+	# Resources
 	${translations_QM}
 )
 
@@ -81,6 +92,14 @@
 	Qt6::Network
 	Qt6::PrintSupport
 	Qt6::Widgets
+)
+
+# Create translations
+file(GLOB translations_SRCS translations/*.ts)
+qt_add_translations(kapow
+	TS_FILES ${translations_SRCS}
+	QM_FILES_OUTPUT_VARIABLE translations_QM
+	LUPDATE_OPTIONS -no-obsolete -locations none
 )
 
 # Optimize build
@@ -139,8 +158,9 @@
 	install(FILES ${translations_QM} DESTINATION ${CMAKE_INSTALL_DATADIR}/kapow/translations)
 	install(FILES doc/kapow.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT doc)
 	install(DIRECTORY icons/hicolor DESTINATION ${CMAKE_INSTALL_DATADIR}/icons)
-	install(FILES icons/kapow.appdata.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)
-	install(FILES icons/kapow.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
+
+	include(cmake/TranslateMetainfo.cmake)
+	process_and_install_metainfo(PO_DIR ${CMAKE_SOURCE_DIR}/icons/po)
 endif()
 
 set_property(SOURCE src/main.cpp APPEND PROPERTY COMPILE_DEFINITIONS KAPOW_DATADIR="${datadir}")

=== tests/CMakeLists.txt ===
include_directories(../src)

# Test filters
qt6_add_executable(test_filters
	test_filters/test_filters.cpp
	../src/filter_model.cpp
	../src/session.cpp
	../src/session_model.cpp
)
target_link_libraries(test_filters PRIVATE Qt6::Core Qt6::Test)
add_test(NAME test_filters COMMAND test_filters)

# Test sessions
qt6_add_executable(test_sessions
	test_sessions/test_sessions.cpp
	../src/session.cpp
	../src/session_model.cpp
)
target_link_libraries(test_sessions PRIVATE Qt6::Core Qt6::Test)
add_test(NAME test_sessions COMMAND test_sessions)

=== debian/changelog ===
kapow (1.6.4-1) unstable; urgency=medium

  * Initial release. (Closes: #1125307)

 -- Maytham Alsudany <maytham@debian.org>  Thu, 15 Jan 2026 18:47:25 +0800

=== debian/control ===
Source: kapow
Section: misc
Maintainer: Maytham Alsudany <maytham@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 qt6-base-dev,
 qt6-tools-dev,
Standards-Version: 4.7.3
Homepage: https://gottcode.org/kapow/
Vcs-Browser: https://salsa.debian.org/debian/kapow
Vcs-Git: https://salsa.debian.org/debian/kapow.git

Package: kapow
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: punch clock program to keep track of your hours
 Kapow is a punch clock program designed to easily keep track of your hours,
 whether you're working on one project or many. Simply clock in and out with
 the Start/Stop button. If you make a mistake in your hours, you can go back
 and edit any of the entries by double-clicking on the session in question.
 Kapow also allows you to easily keep track of the hours since you last billed
 a client, by providing a helpful "Billed" checkbox; the totals will reflect
 your work after the last billed session.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DENABLE_TESTS=ON

=== debian/watch ===
Version: 5
Template: GitHub
Dist: https://github.com/gottcode/kapow
